#include <stdio.h>
#include <stdlib.h>

#define TAMANIO 6

struct punto2D {
	int x, y;
};

typedef struct punto2D PUNTO2D;

PUNTO2D * p0;

int compara( const void *p1, const void *p2 )
{
	PUNTO2D *pa, *pb;
	PUNTO2D v1, v2;
	int area2, d1, d2;

	pa = (PUNTO2D *)p1;
	pb = (PUNTO2D *)p2;

	v1.x = pa->x - p0->x;
	v1.y = pa->y - p0->y;

	v2.x = pb->x - p0->x;
	v2.y = pb->y - p0->y;

	area2 = v1.x * v2.y - v1.y * v2.x;

	if( area2 > 0 ) return -1;
	else if (area2 < 0 ) return 1;
	else {
		d1 = v1.x * v1.x + v1.y * v1.y;
		d2 = v2.x * v2.x + v2.y * v2.y;

		if ( d1 < d2 ) return -1;
		else return 1;
	}
}


void ordenamientoCircular( PUNTO2D * ptos )
{
	int i, minimo;

	// Busco el punto con y mínima, si hay varios de ellos
	// encuentro el punto con x mínima:
	minimo = 0;

	for( i=1; i<TAMANIO; i++ ) {
		if( ptos[i].y < ptos[minimo].y )
			minimo = i;
		else if( ptos[i].y == ptos[minimo].y && ptos[i].x < ptos[minimo].x )
			minimo = i;
	}

	// Intercambio el punto[minimo] con punto[0]
	i = ptos[0].x;
	ptos[0].x = ptos[minimo].x;
	ptos[minimo].x = i;
	
	i = ptos[0].y;
	ptos[0].y = ptos[minimo].y;
	ptos[minimo].y = i;

	p0 = ptos;

	// Ordenamos los puntos!
	qsort( (void *)&ptos[1], TAMANIO-1, sizeof(PUNTO2D), compara );
}


int main( )
{
	PUNTO2D puntos[TAMANIO] = { {2,6}, {4,5}, {5,3}, {5,0}, {2,0}, {0,0} };
	int i;


	ordenamientoCircular( puntos );

	for(i=0; i<TAMANIO; i++) 
		printf( "%d %d\n", puntos[i].x, puntos[i].y );

	printf( "# Ok!\n" );

	return 0;
}
